/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "Transmission/Thrift/ServiceCommunicator.h"
#include "HAL/Runnable.h"
#include "HAL/RunnableThread.h"

#if PLATFORM_WINDOWS
#include "Windows/AllowWindowsPlatformTypes.h"
#endif
#include <Windows.h>
#if PLATFORM_WINDOWS
#include "Windows/HideWindowsPlatformTypes.h"
#endif

class FMixCast;

class MIXCAST_API FServiceMutexThread : public FRunnable
{
public:
	FServiceMutexThread();
	~FServiceMutexThread();

	// FRunnable overrides:
	uint32 Run() override;
	void Stop() override;

private:
	FRunnableThread* thread;

	HANDLE serviceMutex;
	HANDLE stopEvent;
};
