/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "Misc/CommandLine.h"

#define MIXCAST_FLAG "mixcast"
#define MIXCAST_ONLY_FLAG "mixcast-only"

class MIXCAST_API CommandLineUtil
{
protected:
	static bool readValues;

	static bool includesMixCastFlag;
	static bool includesSpectatorModeFlag;

	static void ReadValues()
	{
		if (readValues)
			return;

		const TCHAR* CommandLine = FCommandLine::Get();
		TArray<FString> Tokens;
		TArray<FString> Switches;
		FCommandLine::Parse(CommandLine, Tokens, Switches);

		includesSpectatorModeFlag = Switches.Contains(MIXCAST_ONLY_FLAG);
		includesMixCastFlag = includesSpectatorModeFlag || Switches.Contains(MIXCAST_FLAG);
	}

public:
	// Checks to see if the MixCast flag was specified on the command line.
	static bool IncludesMixCastFlag()
	{
		ReadValues();
		return includesMixCastFlag;
	}
	static bool IncludesSpectatorModeFlag()
	{
		ReadValues();
		return includesSpectatorModeFlag;
	}
};